package com.friday.custody.service.basicService.impl;

import com.friday.custody.entity.DataDictionaryFundOrganizationFormDetailsEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryFundOrganizationFormDetailsService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;

import com.friday.custody.dao.DataDictionaryFundOrganizationFormDao;
import com.friday.custody.entity.DataDictionaryFundOrganizationFormEntity;
import com.friday.custody.service.basicService.DataDictionaryFundOrganizationFormService;
import org.springframework.util.CollectionUtils;

/**
 *
 */
@Service("dataDictionaryFundOrganizationFormService")
public class DataDictionaryFundOrganizationFormServiceImpl extends ServiceImpl<DataDictionaryFundOrganizationFormDao, DataDictionaryFundOrganizationFormEntity> implements DataDictionaryFundOrganizationFormService, DataDictionaryBasicService {

    @Autowired
    private DataDictionaryFundOrganizationFormDetailsService detailsService;
    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryFundOrganizationFormEntity> page = this.page(
                new Query<DataDictionaryFundOrganizationFormEntity>().getPage(params),
                new QueryWrapper<DataDictionaryFundOrganizationFormEntity>()
        );

        return new PageUtils(page);
    }

    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryFundOrganizationFormEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryFundOrganizationFormDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryFundOrganizationFormDetailsEntity::getOriginValue, DataDictionaryFundOrganizationFormDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryFundOrganizationFormEntity::getId, DataDictionaryFundOrganizationFormEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryFundOrganizationFormDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryFundOrganizationFormEntity 查询失败！");
        }
        return result;
    }

    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionaryFundOrganizationFormEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryFundOrganizationFormEntity::getKeyStr
                            ,DataDictionaryFundOrganizationFormEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}